#!/usr/bin/env python

import urllib2
from xml.etree.ElementTree import parse
import time
from MythTV import MSearch
from urlparse import urlparse
import os
import ConfigParser
from httplib import HTTP

class MythTVService:

    CONFFILE = os.path.expanduser("~")+"/.mythtv-scope-location.conf"

    def findBE(self, NEW=False):
        print "Finding Backend"
        self.BACKENDLOCATION = None
        for l in MSearch().searchMythBE():
          if l['st'] == 'urn:schemas-mythtv-org:device:MasterMediaServer:1':
            BACKEND = l['location']
            BACKEND = urlparse(BACKEND)
            self.BACKENDLOCATION = BACKEND.scheme+"://"+BACKEND.netloc
            config = ConfigParser.RawConfigParser()
            if NEW:
                config.add_section('Backend')
            config.set('Backend', 'Location', self.BACKENDLOCATION)
            response = urllib2.urlopen(self.BACKENDLOCATION+'/Myth/GetSetting?Key=MasterServerPort')
            tree = parse(response)
            elem = tree.getroot()
            results = elem.find("Settings")
            MYTHPROTOCOLPORT = "6543"
            #for l in results:
                #MYTHPROTOCOLPORT = l.findtext('Value')
            config.set('Backend', 'MythProtocolPort', MYTHPROTOCOLPORT)
            with open(self.CONFFILE, 'wb') as configfile:
                config.write(configfile)
        return self.BACKENDLOCATION, MYTHPROTOCOLPORT

    def checkURL(self, url):
        try:
            p = urlparse(url)
            h = HTTP(p[1])
            h.putrequest('HEAD', p[2])
            h.endheaders()
            if h.getreply()[0] == 200:
                return 1
            else:
                return 0
        except IOError:
            return 0

    def update_all(self):
        if not os.path.isfile(self.CONFFILE):
            self.findBE(True)
        config = ConfigParser.RawConfigParser()
        config.read(self.CONFFILE)
        
        try:
            self.BACKENDLOCATION = config.get('Backend', 'Location')
        except:
            self.BACKENDLOCATION, MYTHPROTOCOLPORT = self.findBE(True)
            if self.BACKENDLOCATION == None:
                exit(404)
        try:    
            MYTHPROTOCOLPORT = config.get('Backend', 'MythProtocolPort')
        except:
            self.BACKENDLOCATION, MYTHPROTOCOLPORT = self.findBE(True)
            if self.BACKENDLOCATION == None:
                exit(404)
        if not self.checkURL(self.BACKENDLOCATION):
            self.BACKENDLOCATION, MYTHPROTOCOLPORT = self.findBE(True)
            if self.BACKENDLOCATION == None:
                exit(404)
        base = self.BACKENDLOCATION+"/Dvr/GetRecordedList?Descending=true"
        response = urllib2.urlopen(base)
        tree = parse(response)
        elem = tree.getroot()
        results = elem.find("Programs")
        self.lastupdated = time.time()
        RESULTSLIST=[]
        for l in results:
            PROGRAMDATA={}
            PROGRAMDATA['StartTime'] = l.findtext('StartTime')
            #PROGRAMDATA['EndTime'] = l.findtext('EndTime')
            PROGRAMDATA['Title'] = l.findtext('Title')
            PROGRAMDATA['SubTitle'] = l.findtext('SubTitle')
            #PROGRAMDATA['Category'] = l.findtext('Category')
            #PROGRAMDATA['CatType'] = l.findtext('CatType')
            #PROGRAMDATA['Repeat'] = l.findtext('Repeat')
            #PROGRAMDATA['VideoProps'] = l.findtext('VideoProps')
            #PROGRAMDATA['AudioProps'] = l.findtext('AudioProps')
            #PROGRAMDATA['SubProps'] = l.findtext('SubProps')
            #PROGRAMDATA['SeriesId'] = l.findtext('SeriesId')
            #PROGRAMDATA['ProgramId'] = l.findtext('ProgramId')
            #PROGRAMDATA['Stars'] = l.findtext('Stars')
            #PROGRAMDATA['FileSize'] = l.findtext('FileSize')
            #PROGRAMDATA['LastModified'] = l.findtext('LastModified')
            #PROGRAMDATA['ProgramFlags'] = l.findtext('ProgramFlags')
            PROGRAMDATA['FileName'] = l.findtext('FileName')
            #PROGRAMDATA['HostName'] = l.findtext('HostName')
            #PROGRAMDATA['Airdate'] = l.findtext('Airdate')
            PROGRAMDATA['Description'] = l.findtext('Description')
            #PROGRAMDATA['Inetref'] = l.findtext('Inetref')
            PROGRAMDATA['Season'] = l.findtext('Season')
            PROGRAMDATA['Episode'] = l.findtext('Episode')
            PROGRAMDATA['ChanId'] = l.find('Channel').findtext('ChanId')
            #PROGRAMDATA['ChanNum'] = l.find('Channel').findtext('ChanNum')
            #PROGRAMDATA['CallSign'] = l.find('Channel').findtext('CallSign')
            #PROGRAMDATA['IconURL'] = l.find('Channel').findtext('IconURL')
            #PROGRAMDATA['ChannelName'] = l.find('Channel').findtext('ChannelName')
            #PROGRAMDATA['MplexId'] = l.find('Channel').findtext('MplexId')
            #PROGRAMDATA['TransportId'] = l.find('Channel').findtext('TransportId')
            #PROGRAMDATA['ServiceId'] = l.find('Channel').findtext('ServiceId')
            #PROGRAMDATA['NetworkId'] = l.find('Channel').findtext('NetworkId')
            #PROGRAMDATA['ATSCMajorChan'] = l.find('Channel').findtext('ATSCMajorChan')
            #PROGRAMDATA['ATSCMinorChan'] = l.find('Channel').findtext('ATSCMinorChan')
            #PROGRAMDATA['Format'] = l.find('Channel').findtext('Format')
            #PROGRAMDATA['Modulation'] = l.find('Channel').findtext('Modulation')
            #PROGRAMDATA['Frequency'] = l.find('Channel').findtext('Frequency')
            #PROGRAMDATA['FrequencyId'] = l.find('Channel').findtext('FrequencyId')
            #PROGRAMDATA['FrequencyTable'] = l.find('Channel').findtext('FrequencyTable')
            #PROGRAMDATA['FineTune'] = l.find('Channel').findtext('FineTune')
            #PROGRAMDATA['SIStandard'] = l.find('Channel').findtext('SIStandard')
            #PROGRAMDATA['ChanFilters'] = l.find('Channel').findtext('ChanFilters')
            #PROGRAMDATA['SourceId'] = l.find('Channel').findtext('SourceId')
            #PROGRAMDATA['InputId'] = l.find('Channel').findtext('InputId')
            #PROGRAMDATA['CommFree'] = l.find('Channel').findtext('CommFree')
            #PROGRAMDATA['UseEIT'] = l.find('Channel').findtext('UseEIT')
            #PROGRAMDATA['Visible'] = l.find('Channel').findtext('Visible')
            #PROGRAMDATA['XMLTVID'] = l.find('Channel').findtext('XMLTVID')
            #PROGRAMDATA['DefaultAuth'] = l.find('Channel').findtext('DefaultAuth')
            #PROGRAMDATA['Programs'] = l.find('Channel').findtext('Programs')
            #PROGRAMDATA['Status'] = l.find('Recording').findtext('Status')
            #PROGRAMDATA['Priority'] = l.find('Recording').findtext('Priority')
            #PROGRAMDATA['StartTs'] = l.find('Recording').findtext('StartTs')
            #PROGRAMDATA['EndTs'] = l.find('Recording').findtext('EndTs')
            PROGRAMDATA['Id'] = l.find('Recording').findtext('RecordId')
            #PROGRAMDATA['RecGroup'] = l.find('Recording').findtext('RecGroup')
            #PROGRAMDATA['PlayGroup'] = l.find('Recording').findtext('PlayGroup')
            PROGRAMDATA['StorageGroup'] = l.find('Recording').findtext('StorageGroup')
            #PROGRAMDATA['RecType'] = l.find('Recording').findtext('RecType')
            #PROGRAMDATA['DupInType'] = l.find('Recording').findtext('DupInType')
            #PROGRAMDATA['DupMethod'] = l.find('Recording').findtext('DupMethod')
            #PROGRAMDATA['EncoderId'] = l.find('Recording').findtext('EncoderId')
            #PROGRAMDATA['Profile'] = l.find('Recording').findtext('Profile')
            PROGRAMDATA['ContentType'] = 'TELEVISION'
            #PROGRAMDATA['Tagline'] = ''
            #PROGRAMDATA['Director'] = ''
            #PROGRAMDATA['Studio'] = ''
            PROGRAMDATA['BackendLocation'] = self.BACKENDLOCATION
            PROGRAMDATA['MythProtocolPort'] = MYTHPROTOCOLPORT
            artwork = l.find("Artwork")
            artworkinfos = artwork.find("ArtworkInfos")
            for art in artworkinfos:
                PROGRAMDATA[art.findtext('StorageGroup')] = art.findtext('URL')
            RESULTSLIST.append(PROGRAMDATA)
        base = self.BACKENDLOCATION+"/Video/GetVideoList"
        response = urllib2.urlopen(base)
        tree = parse(response)
        elem = tree.getroot()
        results = elem.find("VideoMetadataInfos")
        for l in results:
            VIDEODATA={}
            VIDEODATA['Id'] = l.findtext('Id')
            VIDEODATA['Title'] = l.findtext('Title')
            VIDEODATA['SubTitle'] = l.findtext('SubTitle')
            #VIDEODATA['Tagline'] = l.findtext('Tagline')
            #VIDEODATA['Director'] = l.findtext('Director')
            #VIDEODATA['Studio'] = l.findtext('Studio')
            VIDEODATA['Description'] = l.findtext('Description')
            #VIDEODATA['Certification'] = l.findtext('Certification')
            #VIDEODATA['Inetref'] = l.findtext('Inetref')
            #VIDEODATA['Collectionref'] = l.findtext('Collectionref')
            #VIDEODATA['HomePage'] = l.findtext('HomePage')
            #VIDEODATA['ReleaseDate'] = l.findtext('ReleaseDate')
            #VIDEODATA['AddDate'] = l.findtext('AddDate')
            #VIDEODATA['UserRating'] = l.findtext('UserRating')
            #VIDEODATA['Length'] = l.findtext('Length')
            #VIDEODATA['PlayCount'] = l.findtext('PlayCount')
            VIDEODATA['Season'] = l.findtext('Season')
            VIDEODATA['Episode'] = l.findtext('Episode')
            #VIDEODATA['ParentalLevel'] = l.findtext('ParentalLevel')
            #VIDEODATA['Visible'] = l.findtext('Visible')
            #VIDEODATA['Watched'] = l.findtext('Watched')
            #VIDEODATA['Processed'] = l.findtext('Processed')
            VIDEODATA['ContentType'] = l.findtext('ContentType')
            VIDEODATA['FileName'] = l.findtext('FileName')
            #VIDEODATA['Hash'] = l.findtext('Hash')
            #VIDEODATA['Hostname'] = l.findtext('Hostname')
            #VIDEODATA['Trailer'] = l.findtext('Trailer')
            VIDEODATA['StorageGroup'] = 'Videos'
            VIDEODATA['ChanId'] = "NULL"
            VIDEODATA['StartTime'] = "NULL"
            artwork = l.find("Artwork")
            artworkinfos = artwork.find("ArtworkInfos")
            for art in artworkinfos:
                VIDEODATA[art.findtext('StorageGroup')] = art.findtext('URL')
            VIDEODATA['BackendLocation'] = self.BACKENDLOCATION
            VIDEODATA['MythProtocolPort'] = MYTHPROTOCOLPORT
            RESULTSLIST.append(VIDEODATA)
        return RESULTSLIST
        			
    def search(self, SEARCHTERM=None):
        FILTEREDLIST=[]
        try:
            if time.time() - self.lastupdated > 60:
                self.resultlist = self.update_all()
        except:
            self.resultlist = self.update_all()
        for result in self.resultlist:
            #print result
            try:
                ST = SEARCHTERM.lower() 
            except:
                ST = ''
            if ST == '':
                FILTEREDLIST.append(result)
            elif ST in result['Title'].lower() or ST in result['SubTitle'].lower() or ST in result['Description'].lower():
                FILTEREDLIST.append(result)
        return FILTEREDLIST

    def getDetails(self, TYPE, ID, STARTTIME, CHANID):
        if TYPE == "TELEVISION":
            details_URL = "%s/Dvr/GetRecorded?StartTime=%s&ChanId=%s" % (self.BACKENDLOCATION, STARTTIME, CHANID)
        elif TYPE == "MOVIE":
            details_URL = "%s/Video/GetVideo?Id=%s" % (self.BACKENDLOCATION, ID)
        response = urllib2.urlopen(details_URL)
        tree = parse(response)
        elem = tree.getroot()
        
        DETAILS = {}
        
        DETAILS['Title'] = elem.findtext('Title')
        DETAILS['SubTitle'] = elem.findtext('SubTitle')
        DETAILS['Category'] = elem.findtext('Category')
        DETAILS['Description'] = elem.findtext('Description')
        DETAILS['Inetref'] = elem.findtext('Inetref')
        #DETAILS['FileName'] = elem.findtext('FileName')
        #DETAILS['HostName'] = elem.findtext('HostName')
        DETAILS['Season'] = elem.findtext('Season')
        DETAILS['Episode'] = elem.findtext('Episode')
        DETAILS['ChanId'] = "NULL"
        DETAILS['StartTime'] = "NULL"
        ART = elem.find("Artwork").find("ArtworkInfos")
        for a in ART:
            print a.findtext('StorageGroup')
            DETAILS[a.findtext('StorageGroup')] = a.findtext('URL')
        
        if TYPE == "TELEVISION":
            DETAILS['ContentType'] = 'TELEVISION'
            DETAILS['StartTime'] = elem.findtext('StartTime')
            DETAILS['EndTime'] = elem.findtext('EndTime')
            START = time.strptime(DETAILS['StartTime'], '%Y-%m-%dT%H:%M:%SZ')
            END = time.strptime(DETAILS['EndTime'], '%Y-%m-%dT%H:%M:%SZ')
            DURATION = (time.mktime(END) - time.mktime(START))
            DETAILS['Duration'] = int(DURATION)/60
            #DETAILS['ChanId'] = elem.find('Channel').findtext('ChanId')
            DETAILS['ChanNum'] = elem.find('Channel').findtext('ChanNum')
            DETAILS['CallSign'] = elem.find('Channel').findtext('CallSign')
            DETAILS['IconURL'] = elem.find('Channel').findtext('IconURL')
            DETAILS['ChannelName'] = elem.find('Channel').findtext('ChannelName')
            #DETAILS['MplexId'] = elem.find('Channel').findtext('MplexId')
            #DETAILS['TransportId'] = elem.find('Channel').findtext('TransportId')
            #DETAILS['ServiceId'] = elem.find('Channel').findtext('ServiceId')
            #DETAILS['NetworkId'] = elem.find('Channel').findtext('NetworkId')
            #DETAILS['ATSCMajorChan'] = elem.find('Channel').findtext('ATSCMajorChan')
            #DETAILS['ATSCMinorChan'] = elem.find('Channel').findtext('ATSCMinorChan')
            #DETAILS['Format'] = elem.find('Channel').findtext('Format')
            #DETAILS['Modulation'] = elem.find('Channel').findtext('Modulation')
            #DETAILS['Frequency'] = elem.find('Channel').findtext('Frequency')
            #DETAILS['FrequencyId'] = elem.find('Channel').findtext('FrequencyId')
            #DETAILS['FrequencyTable'] = elem.find('Channel').findtext('FrequencyTable')
            #DETAILS['FineTune'] = elem.find('Channel').findtext('FineTune')
            #DETAILS['SIStandard'] = elem.find('Channel').findtext('SIStandard')
            #DETAILS['ChanFilters'] = elem.find('Channel').findtext('ChanFilters')
            #DETAILS['SourceId'] = elem.find('Channel').findtext('SourceId')
            #DETAILS['InputId'] = elem.find('Channel').findtext('InputId')
            #DETAILS['CommFree'] = elem.find('Channel').findtext('CommFree')
            #DETAILS['UseEIT'] = elem.find('Channel').findtext('UseEIT')
            #DETAILS['Visible'] = elem.find('Channel').findtext('Visible')
            #DETAILS['XMLTVID'] = elem.find('Channel').findtext('XMLTVID')
            #DETAILS['DefaultAuth'] = elem.find('Channel').findtext('DefaultAuth')
            #DETAILS['Programs'] = elem.find('Channel').findtext('Programs')
            #DETAILS['Status'] = elem.find('Recording').findtext('Status')
            #DETAILS['Priority'] = elem.find('Recording').findtext('Priority')
            #DETAILS['StartTs'] = elem.find('Recording').findtext('StartTs')
            #DETAILS['EndTs'] = elem.find('Recording').findtext('EndTs')
            #DETAILS['RecordId'] = elem.find('Recording').findtext('RecordId')
            #DETAILS['RecGroup'] = elem.find('Recording').findtext('RecGroup')
            #DETAILS['PlayGroup'] = elem.find('Recording').findtext('PlayGroup')
            #DETAILS['StorageGroup'] = elem.find('Recording').findtext('StorageGroup')
            #DETAILS['RecType'] = elem.find('Recording').findtext('RecType')
            #DETAILS['DupInType'] = elem.find('Recording').findtext('DupInType')
            #DETAILS['DupMethod'] = elem.find('Recording').findtext('DupMethod')
            #DETAILS['EncoderId'] = elem.find('Recording').findtext('EncoderId')
            #DETAILS['Profile'] = elem.find('Recording').findtext('Profile')
            DETAILS['Airdate'] = elem.findtext('Airdate')
            #DETAILS['CatType'] = elem.findtext('CatType')
            #DETAILS['Repeat'] = elem.findtext('Repeat')
            #DETAILS['VideoProps'] = elem.findtext('VideoProps')
            #DETAILS['AudioProps'] = elem.findtext('AudioProps')
            #DETAILS['SubProps'] = elem.findtext('SubProps')
            DETAILS['SeriesId'] = elem.findtext('SeriesId')
            DETAILS['ProgramId'] = elem.findtext('ProgramId')
            DETAILS['Stars'] = elem.findtext('Stars')
            DETAILS['FileSize'] = elem.findtext('FileSize')
            #DETAILS['LastModified'] = elem.findtext('LastModified')
            #DETAILS['ProgramFlags'] = elem.findtext('ProgramFlags')
        elif TYPE == "MOVIE":
            DETAILS['Id'] = elem.findtext('Id')
            DETAILS['Tagline'] = elem.findtext('Tagline')
            DETAILS['Director'] = elem.findtext('Director')
            DETAILS['Studio'] = elem.findtext('Studio')
            DETAILS['Certification'] = elem.findtext('Certification')
            #DETAILS['Collectionref'] = elem.findtext('Collectionref')
            #DETAILS['HomePage'] = elem.findtext('HomePage')
            DETAILS['ReleaseDate'] = elem.findtext('ReleaseDate')
            #DETAILS['AddDate'] = elem.findtext('AddDate')
            DETAILS['Stars'] = float(elem.findtext('UserRating'))/10.0
            DETAILS['Duration'] = elem.findtext('Length')
            #DETAILS['PlayCount'] = elem.findtext('PlayCount')
            #DETAILS['ParentalLevel'] = elem.findtext('ParentalLevel')
            #DETAILS['Visible'] = elem.findtext('Visible')
            #DETAILS['Watched'] = elem.findtext('Watched')
            #DETAILS['Processed'] = elem.findtext('Processed')
            DETAILS['ContentType'] = elem.findtext('ContentType')  ## MOVIE
            #DETAILS['FileName'] = elem.findtext('FileName')
            #DETAILS['Hash'] = elem.findtext('Hash')
            #DETAILS['Hostname'] = elem.findtext('Hostname')
            DETAILS['Trailer'] = elem.findtext('Trailer')
            #DETAILS['StorageGroup'] = 'Videos'

        return DETAILS
        



if __name__ == '__main__':
    mt = MythTVService()
    results = mt.search('house')
    for l in results:
        print l['Title'], l['SubTitle']
    exit(0)
    '''Action, Adult, Animals, Art_Music, Business, Children, Comedy, Crime/Mystery, Documentary, Drama, Educational, Food, Game, Health/Medical, History, Horror, HowTo, Misc, Movie, News, Reality, Romance, Science/Nature, SciFi/Fantasy, Shopping, Soaps, Spiritual, Sports, Talk, Travel, Unknown, War, Western'''
